clear variables


homedir = cd;

 %% Video selection dialogue

n = 1;
stop_io = 0;

while stop_io == 0

	sampledates{n} = uigetdir(cd,'Select test date folder');

	stopcond = questdlg('Would you like to choose another test date?', ...
					'Anotha one?',...
					'Yes','No','Yes');
	switch stopcond
		case 'Yes'
			stop_io = 0;
			n = n+1;
		case 'No'
			stop_io = 1;
	end
	
end

%%

t0_m = 11.1; % s


for b = 1:length(sampledates)

cd(sampledates{b})


filenames_char =  ls('*.xlsx');

[s{b},~] = size(filenames_char);

for i = 1:s{b}
	filenames{i} = filenames_char(i,:);
end

	

L0_m{b} = textread('sample lengths.txt','%f','delimiter','\n','whitespace','');
L0 = L0_m{b};

w0_m{b} = textread('width.txt','%f','delimiter','\n','whitespace','');
w0 = w0_m{b};


th0_m{b} = textread('thickness.txt','%f','delimiter','\n','whitespace','');
th0 = th0_m{b};


A = w0.*th0*(10^-3)^2; % mm to m conversion

t0 = t0_m(1);


%% shorten filename, load data from sheets 
for a = 1:s{b}
	

filename{b,a} = char(filenames(a));



while contains(filename{b,a},' ') == 1
filename{b,a} = strrep(filename{b,a},' ','');
end

filename_cut = strrep(filename{b,a},'.xlsx','');

[status,sheets] = xlsfinfo(filename_cut);
[~,n] = size(sheets);

%  n = 3;
disp(filename{b,a})

% display number of trails
disp(['n = ', num2str(n)])

% l0 = ones(n,1)*L0;
l0 = L0;

%% excluding samples from stress-strain plot (still included in summary table)

plotIO{b,a} = 1:n;

	  stop_io = 0;
while stop_io == 0
	
	[indx,tf] = listdlg('PromptString',...
	{'Exclude files?','Select data sheets for exclusion'},...
	'SelectionMode','multiple',...
	'ListString',sheets(plotIO{a}));

	if tf == 1
		plotIO{b,a}(indx) = '';

	stopcond = questdlg('Would you like to exclude more files?', ...
					'Exclude more?',...
					'Yes','No','No');
		switch stopcond
			case 'Yes'
		stop_io = 0;
			case 'No'
		stop_io = 1;
		end
	else
		stop_io = 1;
	end
end

%%

% saves data from excel file to data_s1 for step 1 data and data_s2 for
% step 2 data 
for i = 1:n
[data{i}] = readtable(filename_cut,'Sheet',i,'PreserveVariableNames',true);
data{i} = table2array(data{i});
end


for i = 1:n
t{i} = [data{i}(:,2)]; % sec
t_p{i} = t{i}(t{i}>t0);
Disp{i} = [data{i}(t{i}>t0,3)]; % mm
Load{i} = [data{i}(:,4)]; % N
end


end

%% zero load, calculate stress & smoothed stress (S, S2), strain (e)
for a = 1:s{b}
	% initial load as average of first 10 seconds of data
	for i = 1:n
	Load0(i) = mean(Load{i}(t{i}<10));
	Load1(i) = mean(Load{i}(t{i}>t0 & t{i}<12));
	Load{i} = Load{i}(t{i}>t0)-Load0(i);
	end
		
	for i = 1:n
		S{i} = Load{i}/A(n);
		e{i} = (Disp{i}-Disp{i}(1))/l0(i);
	end
	
	for i = 1:n
	S2{i} = smooth(S{i},50);
	
	end
end

%% stress-strain plot

for a = 1:s{b}

	figure
	
	hold on
	
	for i = 1:n
		if isempty(find(plotIO{b,a} == i,1)) == 0 
					plot(e{i},S2{i}/1000)
		xlabel('\epsilon')
		ylabel('\sigma (kPa)')	
		title(strrep(strrep(filename{b,a},'_',' '),'.xlsx',''))
		end
	end
	
	legend(sheets(plotIO{b,a}),'location','southeast')
end

%% save variables to table, data file
for a = 1:s{b}


for i = 1:n
	[TS{b,a}(i),i_TS(i)] = max(S2{i});
	e_TS{b,a}(i) = e{i}(i_TS(i));
	t_TS{b,a}(i) = t{i}(i_TS(i))+10;
	E_ss{b,a}(i,:) = polyfit(e{i}(e{i} < e_TS{b,a}(i)*0.5),S2{i}(e{i} < e_TS{b,a}(i)*0.5),1); %modulus for e < 0.14, Pa
	E_ms{b,a}(i,:) = polyfit(e{i}(e{i} < e_TS{b,a}(i)*0.75),S2{i}(e{i} < e_TS{b,a}(i)*0.75),1); %modulus for e < 0.4, Pa
	
	Tuf{b,a}(i) = trapz(e{i}(e{i} < e_TS{b,a}(i)),S2{i}(e{i} < e_TS{b,a}(i)));
	
end

sheets = sheets(1:n);

Sum = table(sheets',E_ss{b,a}(:,1)/10^3,E_ms{b,a}(:,1)/10^3,TS{b,a}'/10^3,e_TS{b,a}',Tuf{b,a}(:)/10^3); %kPa
Sum.Properties.VariableNames = {'Sample','E_ss(kPa)','E_ms(kPa)','TS(kPa)','e|TS','Toughness (kPa)'};

SUM{b,a} = Sum;
Sum


save(append(strrep(filenames{a},'.xlsx',''),'.mat'),'sheets','e','S2','t_p','L0','A','e_TS','t_TS')



end

cd(homedir)

end

